define("epi-cms/project/command/SortProjectItems", [
    "dojo/_base/declare",
    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.project.command.sortprojectitems",
    // Parent class
    "epi/shell/command/OptionCommand"
], function(
    declare,
    // Resources
    localizations,
    // Parent class
    OptionCommand
) {

    return declare([OptionCommand], {

        // category: [readonly] String
        //      A category which provides a hint about how the command could be displayed.
        category: "context",

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: localizations.label,

        // options: [readonly] Array
        //      An array of options objects that can be selected.
        options: null,

        // property: [readonly] String
        //      The name of the property on the model that will be set with the selected value on execute.
        property: "projectItemSortOrder",

        constructor: function() {
            this.options = [
                { label: localizations.nameascending, value: "+Name" },
                { label: localizations.namedescending, value: "-Name" },
                { label: localizations.type, value: "+TypeIdentifier" },
                { label: localizations.modifieddescending, value: "-DateModified" },
                { label: localizations.modifiedascending, value: "+DateModified" }
            ];
        }
    });
});
